<?php

namespace DsbNext\Controllers;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;

class DashboardTAController{
    
    protected $crudService;
    
    public function __construct($connection, $environment, $util, $crudService) {
        $this->crudService    = $crudService;
        $this->connection      = $connection;
        $this->environment     = $environment;
        $this->util            = $util;
    }
    
    public function previousDayAFDeliveryTA(Request\Filter $request, Response $response) {
        $params = ['CDFILCENTCMP'];
        $conditions = $this->util->prepareConditions($params);
        
        $data = $this->crudService->getFilteredDataSet('previousDayAFDeliveryTA', $conditions)->getRows();
        $response->addDataSet(new DataSet("previousDayAFDeliveryTA", $data));
    }
    
    public function afApprovalTracking(Request\Filter $request, Response $response) {
        $params = ['CDFILCENTCMP'];
        $conditions = $this->util->prepareConditions($params);
        
        $data = $this->crudService->getFilteredDataSet('afApprovalTracking', $conditions)->getRows();
        $response->addDataSet(new DataSet("afApprovalTracking", $data));
    }
    
    public function aFDeliveryLastWeekTA(Request\Filter $request, Response $response) {
        $params = ['CDFILCENTCMP'];
        $conditions = $this->util->prepareConditions($params);
        
        $data = $this->crudService->getFilteredDataSet('aFDeliveryLastWeekTA', $conditions)->getRows();
        $response->addDataSet(new DataSet("aFDeliveryLastWeekTA", $data));
    }
    
    public function aFDeliveryLastWeekGrid(Request\Filter $request, Response $response) {
        $params = ['CDFILCENTCMP'];
        $conditions = $this->util->prepareConditions($params);
        $filter = $request->getFilterCriteria()->getConditions();
        
        $data = $this->crudService->getFilteredDataSet('aFDeliveryLastWeekGrid', array_merge($conditions, $filter))->getRows();
        $response->addDataSet(new DataSet("aFDeliveryLastWeekGrid", $data));
    }
}