import { Metadata } from '@zeedhi/core';
import {
  Modal,
  ModalService,
  Form,
  GridEditable,
} from '@zeedhi/common';

export class FilterParamDashModalController {
  private filterParamDashModal!: Modal;
  
  public async createFilterParamDashModal() {
    this.filterParamDashModal = await ModalService.createFromJson('/modals/filterParamDashModal', true);
    this.filterParamDashModal.show();
  }
  
  public destroyFilterParamDashModal() {
    this.filterParamDashModal?.destroy();
  }
  
  public openFilterParamDashModal() {
    this.filterParamDashModal.show();
  }
  
  public closeFilterParamDashModal() {
    this.filterParamDashModal.hide();
    this.clearInputsFilter();
  }
  
  public clearInputsFilter() {
    const form = Metadata.getInstance<Form>('formFilterParamDash');
    form.clearForm();
  }
  
  public async applyFilterDash() {
    const filter = Metadata.getInstance<Form>('formFilterParamDash');
    const grid = Metadata.getInstance<GridEditable>('parametersEditGrid');
    
    if (filter.value.CDFILIAL != null && filter.value.NRPAINEL != null) {
      const conditions = {
        CDFILIAL: filter.value.CDFILIAL.CDFILIAL,
        NRPAINEL: filter.value.NRPAINEL.NRPAINEL,
      };
      this.filterParamDashModal.hide();
      grid.datasource.filter = conditions;
      grid.datasource.get();
    } else {
      filter.validate();
    }
  }
}
