import { Metadata } from '@zeedhi/core';
import { TekGrid } from '@zeedhi/teknisa-components-common';
import {
  Modal,
  ModalService,
  SelectMultiple,
  Form,
} from '@zeedhi/common';

export class FormAddOperatorExModalController {
  private addOperatorEx!: Modal;

  public async createAddOperatorEx() {
    this.addOperatorEx = await ModalService.createFromJson('/modals/formAddOperatorExModal', true);
  }
  
  public async openAddOperatorEx() {
    await this.addOperatorEx.show();
    const grid = Metadata.getInstance<TekGrid>('exceptionOperatorGrid');
    const selectData = Metadata.getInstance<SelectMultiple>('operatorsEx').datasource;
    const data = grid.datasource.filter;
    selectData.setFilter(data);
  }
  
  public closeAddOperatorEx() {
    const form = Metadata.getInstance<Form>('formExOp');
    form.clearForm();
    this.addOperatorEx.hide();
  }
  
  public saveOperatorEx() {
    const grid = Metadata.getInstance<TekGrid>('exceptionOperatorGrid');
    const selectData = Metadata.getInstance<SelectMultiple>('operatorsEx');
    console.warn(grid, selectData);
  }
}
